#!/bin/sh

# NOTE: Must be run as root, so you probably need to setup sudo for this.

if test -f /tmp/dres; then rm -f /tmp/dres; fi

ls /dev/disk/by-id/* | grep -ve '-part' -ve '/wwn-' |
while read DISK
do
    DISKDEV=`ls -l $DISK | awk -F/ '{print $NF}'`

    #check if disk is removable
    RM=0
    RM=`cat /sys/block/$DISKDEV/removable`
    if test $RM -ne 0
    then
        continue
    fi

    DRES=`sudo /usr/sbin/smartctl -H -n standby $DISK`
    DCODE=$?
    DSTBY=$(( $DCODE & 2 ))
    DFAIL=$(( $DCODE & 8 ))
    DWARN=$(( $DCODE & 32 ))

    if test $DSTBY -ne 0
    then
        COLOR="4&clear"
    elif test $DFAIL -ne 0
    then
        COLOR="1&red"
    elif test $DWARN -ne 0
    then
        COLOR="2&yellow"
    else
        COLOR="3&green"
    fi

    echo "${COLOR} $DISK (/dev/$DISKDEV)"

    echo "${COLOR} $DISK (/dev/$DISKDEV)" | cut -c2- >>/tmp/dres
    echo "" >>/tmp/dres
    echo "$DRES" | egrep -v "^smartctl|^Copyright|^$|^===" >>/tmp/dres
    echo "-----------------------------------------------------------------------------" >>/tmp/dres
    echo "" >>/tmp/dres
    echo "" >>/tmp/dres
done >/tmp/dcheck

COLOR=`cat /tmp/dcheck | awk '{print $1}' | sort | uniq | head -1 | cut -c3-`

$XYMON $XYMSRV "status ${MACHINE}.smart ${COLOR} SMART Health Check

`cat /tmp/dcheck | cut -c2-`

============================== Detailed status ==============================

`cat /tmp/dres`
"

rm -f /tmp/dres /tmp/dcheck

exit 0
